# -*- coding: utf-8 -*-
import im_wireless as imw
import datetime as dt
import time
from PIL import Image

# i2c
SLAVE_ADR = 0x30        # hatのI2Cアドレスは0x30 ~ 0x33

iwc = imw.IMWireClass(SLAVE_ADR)                # classの初期化

row = 12

def receiveData( in1 ):
    byte_list = []
    stime = time.time()
    while( in1 > 0 ):
        rx_data = iwc.Read_920()                        # 受信処理
        if len(rx_data) >= 1:
            stime = time.time()
            print( in1 )
            print(rx_data, end='')                          # 受信データを表示
            if ( len(rx_data) >= 11 and rx_data[2] == ',' and
                rx_data[7] == ',' and rx_data[10] == ':' ):
                in1 -= 1
                data_list = rx_data[11:].strip().split(',')
                if len( data_list ) > 1:
                    for data_lists in data_list:
                        byte_list.append( int( data_lists, 16 ) )
                else:
                    if in1 > 1:
                        byte_list = []
                    break
        else:
            etime = time.time() - stime
            if etime > 60:
                byte_list = []
                break
    byte_data = bytearray( byte_list )
    return byte_data

# Main
if __name__ == '__main__':
    iwc.Write_920( "DCIO" )
    byte_data = bytearray()
    try:                                                         
        while True:
            rx_data = iwc.Read_920()                        # 受信処理
            rx_size = len(rx_data)
            if rx_size >= 1: 
                print(rx_data, end='')                          # 受信データを表示
                
                if ( rx_size > 11 and rx_size < 30 and rx_data[2] == ',' and
                    rx_data[7] == ',' and rx_data[10] == ':' ):
                    dt_time = dt.datetime.now()
                    data_list = rx_data[11:].strip().split(',')
                    dat_size = 0
                    size_dat = ""
                    for data_lists in reversed( data_list ):
                        size_dat += data_lists
                    if size_dat == "":
                        continue
                    else:
                        dat_size = int( size_dat, 16 )
                    print( dat_size )
                    img_data = receiveData( dat_size )
                    print( len( img_data ) )
                    if len( img_data ) == ( ( dat_size - 1 ) * row ):
                        img = Image.frombytes( 'RGB', ( 120, 90 ), bytes( img_data ) )

                        f_name = 'PIC_' + dt_time.strftime( '%y%m%d-%H%M' ) + '.jpg'
                        img.save( f_name, quality=95 )
                        print( "Picture File Saved:" + f_name )

    except KeyboardInterrupt:
        iwc.gpio_clean()
        print ('END')