import im_wireless as imw
import datetime as dt
from picamera import PiCamera
from PIL import Image
from time import sleep

# i2c
SLAVE_ADR = 0x30        # hatのI2Cアドレスは0x30 ~ 0x33

camera = PiCamera()
camera.resolution = ( 1024, 768 )

row = 12

iwc = imw.IMWireClass( SLAVE_ADR )                # classの初期化

def Shot_pic( in1 ):
    f_name = 'PIC_' + in1.strftime('%y%m%d-%H%M') + '.jpg'
    print( f_name )
    f_name = "/home/pi/share/pic/" + f_name
    camera.capture( f_name, resize=( 120, 90 ) )
    return( f_name )

def sendFile( in1 ):
    img = Image.open( in1 )
    buf_data = img.tobytes()
    img_data = [] 
    for buf_datas in buf_data:
        img_data.append( format( buf_datas, '02x' ) )

    row_no = int( len( img_data ) / row ) + 1
    print( row_no )
    buf = "TXDA"
    dum = row_no
    while( dum > 0 ):
        buf += format( int( dum % 256 ), '02x' )
        dum = int( dum / 256 )
    print( buf )
    iwc.Write_920( buf )
    sleep( 0.5 )

    for offset in range( row_no ):
        buf = "TXDA"
        for img_datas in img_data[ ( offset * row ):( ( offset + 1 ) * row ) ]:
            buf += img_datas
        print( buf )
        while( iwc.busy_status() == 1 ):
            sleep( 100e-3 )
        iwc.Write_920( buf )
        sleep( 0.5 )

# Main
if __name__ == '__main__':
    dt_time = dt.datetime.now()
    iwc.Write_920( "DCIO" )
    sendFile( Shot_pic( dt_time ) )
    iwc.gpio_clean()